/*
 * Bishof_Mov.c
 *
 *  Created on: Sep 14, 2013
 *      Author: rt-group
 */

#include "global_varibal.h"
#include "Bisof_Mov.h"
#include "math.h"


int Bishof_Mov (int* prow1, int* pcol1, int* prow2, int* pcol2  )
{
	int mov_flag = 0 ;

	int i=  1, row_calc , col_calc , row_calc_abs , col_calc_abs ;

	row_calc = *prow2 - *prow1;

	col_calc = *pcol2 - *pcol1;

	row_calc_abs = abs(row_calc);

	col_calc_abs = abs(col_calc);

	if  (row_calc_abs != col_calc_abs)
	{
		mov_flag = 0 ;

		return mov_flag ;
	}
	else if ( (row_calc > 0) && (col_calc > 0) )
	{
		for (i = 1 ; i <=  row_calc_abs ; ++i)

			if ( Piecedef[*prow1][*pcol1].Piece_Color ==  Piecedef[*prow1 + i][*pcol1 + i].Piece_Color )
			{
				mov_flag = 0 ;

				return mov_flag ;
			}
			else if (  (Piecedef[*prow1 + i][*pcol1 + i].Piece_Color !=  Empty) && (Piecedef[*prow1][*pcol1].Piece_Color !=  Piecedef[*prow1 + i][*pcol1 + i].Piece_Color) )
			{
				if ( (*prow2 != *prow1 + i) && (*pcol2 != *pcol1 + i) )
				{
					mov_flag = 0 ;

					return mov_flag ;
				}
			}
	}
	else if ( (row_calc > 0) && (col_calc < 0) )
	{
		for (i = 1 ; i <=  row_calc_abs ; ++i)

			if ( Piecedef[*prow1][*pcol1].Piece_Color ==  Piecedef[*prow1 + i][*pcol1 - i].Piece_Color )
			{
				mov_flag = 0 ;

				return mov_flag ;
			}
			else if (  (Piecedef[*prow1 + i][*pcol1 - i].Piece_Color !=  Empty) && (Piecedef[*prow1][*pcol1].Piece_Color !=  Piecedef[*prow1 + i][*pcol1 - i].Piece_Color) )
			{
				if ( (*prow2 != *prow1 + i) && (*pcol2 != *pcol1 - i) )
				{
					mov_flag = 0 ;

					return mov_flag ;
				}
			}
	}
	else if ( (row_calc < 0) && (col_calc > 0) )
	{
		for (i = 1 ; i <=  row_calc_abs ; ++i)

			if ( Piecedef[*prow1][*pcol1].Piece_Color ==  Piecedef[*prow1 - i][*pcol1 + i].Piece_Color )
			{
				mov_flag = 0 ;

				return mov_flag ;
			}
			else if (  (Piecedef[*prow1 - i][*pcol1 + i].Piece_Color !=  Empty) && (Piecedef[*prow1][*pcol1].Piece_Color !=  Piecedef[*prow1 - i][*pcol1 + i].Piece_Color) )
			{
				if ( (*prow2 != *prow1 - i) && (*pcol2 != *pcol1 + i) )
				{
					mov_flag = 0 ;

					return mov_flag ;
				}
			}
	}
	else if ( (row_calc < 0) && (col_calc < 0) )
	{
		for (i = 1 ; i <=  row_calc_abs ; ++i)

			if ( Piecedef[*prow1][*pcol1].Piece_Color ==  Piecedef[*prow1 - i][*pcol1 - i].Piece_Color )
			{
				mov_flag = 0 ;

				return mov_flag ;
			}
			else if (  (Piecedef[*prow1 - i][*pcol1 - i].Piece_Color !=  Empty) && (Piecedef[*prow1][*pcol1].Piece_Color !=  Piecedef[*prow1 - i][*pcol1 - i].Piece_Color) )
			{
				if ( (*prow2 != *prow1 - i) && (*pcol2 != *pcol1 - i) )
				{
					mov_flag = 0 ;

					return mov_flag ;				}
			}
	}

	mov_flag = 1 ;

	return mov_flag ;
}

