/*
 * King_Mov.c
 *
 *  Created on: Sep 14, 2013
 *      Author: Nir Geron
 */

#include "global_varibal.h"
#include "King_Mov.h"

int King_Mov (int* prow1, int* pcol1, int* prow2, int* pcol2 )
{
	int mov_flag = 0 ;

	int i=1, row_calc , col_calc , row_calc_abs , col_calc_abs ;

	row_calc = *prow2 - *prow1;

	col_calc = *pcol2 - *pcol1;

	row_calc_abs = abs(row_calc);

	col_calc_abs = abs(col_calc);

	if (row_calc_abs != col_calc_abs) /*&& ((row_calc_abs != 1 ) || (col_calc_abs != 1))) && (*prow1 != *prow2) && (*pcol1 != *pcol2))*/
	{
		if ((row_calc_abs > 2 ) || (col_calc_abs > 2))
		{
			if ((*prow1 != *prow2) || (*pcol1 != *pcol2))
			{
				mov_flag = 0 ;

				return mov_flag ;
			}
		}
		else if ( ( (row_calc_abs == 2) && (col_calc_abs >= 1) ) ||  ( (row_calc_abs >= 1) && (col_calc_abs == 2) ) )
		{
			mov_flag = 0 ;

			return mov_flag ;
		}
		else if ((Piecedef[*prow1][*pcol1].First_mov == 1) && (row_calc_abs == 0) && (col_calc_abs == 2))
		{
			if (col_calc < 0 )
			{
				if ((Piecedef[*prow1][1].Piece_Type == Rook) && (Piecedef[*prow1][1].First_mov == 1))
				{
					if ((Piecedef[*prow1][*pcol1 - 1].Piece_Type == No_piece) && (Piecedef[*prow1][*pcol1 - 2].Piece_Type == No_piece) && (Piecedef[*prow1][*pcol1 - 3].Piece_Type == No_piece))
					{
						mov_flag = 2 ;

						return mov_flag ;
					}
					else
					{
						mov_flag = 0 ;

						return mov_flag ;
					}
				}
				else if (Piecedef[*prow1][1].First_mov == 0)
				{
					mov_flag = 0 ;

					return mov_flag ;
				}
			}
			else if (col_calc > 0 )
			{
				if ((Piecedef[*prow1][8].Piece_Type == Rook)  && (Piecedef[*prow1][8].First_mov == 1))
				{
					if ((Piecedef[*prow1][*pcol1 + 1].Piece_Type == No_piece) && (Piecedef[*prow1][*pcol1 + 2].Piece_Type == No_piece))
					{
						mov_flag = 3 ;

						return mov_flag ;
					}
					else
					{
						mov_flag = 0 ;

						return mov_flag ;
					}
				}
				else if (Piecedef[*prow1][8].First_mov == 0)
				{
					mov_flag = 0 ;

					return mov_flag ;
				}
			}
		}
		else if ((row_calc_abs > 1 ) || (col_calc_abs > 1))
		{
			if ((*prow1 != *prow2) || (*pcol1 != *pcol2))
			{
				mov_flag = 0 ;

				return mov_flag ;
			}
		}

	}

	if  (row_calc_abs == col_calc_abs)
	{
		if ( (row_calc_abs <= 1 ) || (col_calc_abs <= 1) )
		{

			if      ( (row_calc > 0) && (col_calc > 0) )
			{
				for (i = 1 ; i <=  row_calc_abs ; ++i)

					if ( Piecedef[*prow1][*pcol1].Piece_Color ==  Piecedef[*prow1 + i][*pcol1 + i].Piece_Color )
					{
						mov_flag = 0 ;

						return mov_flag ;
					}
					else if (  (Piecedef[*prow1 + i][*pcol1 + i].Piece_Color !=  Empty) && (Piecedef[*prow1][*pcol1].Piece_Color !=  Piecedef[*prow1 + i][*pcol1 + i].Piece_Color) )
					{
						if ( (*prow2 != *prow1 + i) && (*pcol2 != *pcol1 + i) )
						{
							mov_flag = 0 ;

							return mov_flag ;
						}
					}
			}

			else if ( (row_calc > 0) && (col_calc < 0) )
			{
				for (i = 1 ; i <=  row_calc_abs ; ++i)

					if ( Piecedef[*prow1][*pcol1].Piece_Color ==  Piecedef[*prow1 + i][*pcol1 - i].Piece_Color )
					{
						mov_flag = 0 ;

						return mov_flag ;
					}
					else if (  (Piecedef[*prow1 + i][*pcol1 - i].Piece_Color !=  Empty) && (Piecedef[*prow1][*pcol1].Piece_Color !=  Piecedef[*prow1 + i][*pcol1 - i].Piece_Color) )
					{
						if ( (*prow2 != *prow1 + i) && (*pcol2 != *pcol1 - i) )
						{
							mov_flag = 0 ;

							return mov_flag ;
						}
					}
			}
			else if ( (row_calc < 0) && (col_calc > 0) )
			{
				for (i = 1 ; i <=  row_calc_abs ; ++i)

					if ( Piecedef[*prow1][*pcol1].Piece_Color ==  Piecedef[*prow1 - i][*pcol1 + i].Piece_Color )
					{
						mov_flag = 0 ;

						return mov_flag ;
					}
					else if (  (Piecedef[*prow1 - i][*pcol1 + i].Piece_Color !=  Empty) && (Piecedef[*prow1][*pcol1].Piece_Color !=  Piecedef[*prow1 - i][*pcol1 + i].Piece_Color) )
					{
						if ( (*prow2 != *prow1 - i) && (*pcol2 != *pcol1 + i) )
						{
							mov_flag = 0 ;

							return mov_flag ;
						}
					}
			}
			else if ( (row_calc < 0) && (col_calc < 0) )
			{
				for (i = 1 ; i <=  row_calc_abs ; ++i)

					if ( Piecedef[*prow1][*pcol1].Piece_Color ==  Piecedef[*prow1 - i][*pcol1 - i].Piece_Color )
					{
						mov_flag = 0 ;

						return mov_flag ;
					}
					else if (  (Piecedef[*prow1 - i][*pcol1 - i].Piece_Color !=  Empty) && (Piecedef[*prow1][*pcol1].Piece_Color !=  Piecedef[*prow1 - i][*pcol1 - i].Piece_Color) )
					{
						if ( (*prow2 != *prow1 - i) && (*pcol2 != *pcol1 - i) )
						{
							mov_flag = 0 ;

							return mov_flag ;
						}
					}
			}
		}
		else if ((row_calc_abs != 1 ) || (col_calc_abs != 1))
		{
			mov_flag = 0 ;

			return mov_flag ;
		}

	}
	else if  ( ((*prow1 == *prow2) || (*pcol1 == *pcol2)))
	{
		if ((row_calc_abs <= 1 ) || (col_calc_abs <= 1))
		{

			if (*pcol1 == *pcol2)
			{
				if (*prow1 < *prow2)
				{
					for (i = *prow1+1 ; i <= *prow2; ++i)
					{
						if ( Piecedef[*prow1][*pcol1].Piece_Color ==  Piecedef[i][*pcol2].Piece_Color )
						{
							mov_flag = 0 ;

							return mov_flag ;
						}
						else if (  (Piecedef[i][*pcol2].Piece_Color !=  Empty) && (Piecedef[*prow1][*pcol1].Piece_Color !=  Piecedef[i][*pcol2].Piece_Color) )
						{
							if ( *prow2 == i )
							{
								mov_flag = 1 ;

								return mov_flag ;
							}
						}
					}
				}
				else if (*prow1 > *prow2)
				{
					for (i = *prow1-1; i >= *prow2; --i)
					{
						if ( Piecedef[*prow1][*pcol1].Piece_Color ==  Piecedef[i][*pcol2].Piece_Color )
						{
							mov_flag = 0 ;

							return mov_flag ;
						}
						else if (  (Piecedef[i][*pcol2].Piece_Color !=  Empty) && (Piecedef[*prow1][*pcol1].Piece_Color !=  Piecedef[i][*pcol2].Piece_Color) )
						{
							if ( *prow2 == i )
							{
								mov_flag = 1 ;

								return mov_flag ;
							}
						}
					}
				}
			}
			else if (*prow1 == *prow2)
			{
				if ( *pcol1 < *pcol2)
				{
					for (i = *pcol1+1 ; i <= *pcol2; ++i)
					{
						if ( Piecedef[*prow1][*pcol1].Piece_Color ==  Piecedef[*prow2][i].Piece_Color )
						{
							mov_flag = 0 ;

							return mov_flag ;
						}
						else if (  (Piecedef[*prow1][i].Piece_Color !=  Empty)  && (Piecedef[*prow1][*pcol1].Piece_Color !=  Piecedef[*prow2][i].Piece_Color) )
						{
							if ( *pcol2 == i )
							{
								mov_flag = 1 ;

								return mov_flag ;
							}
						}
					}
				}
				else if ( *pcol1 > *pcol2)
				{
					for (i = *pcol1-1 ; i >= *pcol2; --i)
					{
						if ( Piecedef[*prow1][*pcol1].Piece_Color ==  Piecedef[*prow2][i].Piece_Color )
						{
							mov_flag = 0 ;

							return mov_flag ;
						}
						else if (  (Piecedef[*prow1][i].Piece_Color !=  Empty)  && (Piecedef[*prow1][*pcol1].Piece_Color !=  Piecedef[*prow1][i].Piece_Color) )
						{
							if ( *pcol2 != i )
							{
								mov_flag = 1 ;

								return mov_flag ;						}
						}
					}
				}
			}
		}
		else if ((row_calc_abs != 1 ) || (col_calc_abs != 1))
		{
			mov_flag = 0 ;

			return mov_flag ;
		}
	}

	mov_flag = 1;

	return mov_flag ;





}


