/*
 * global_veribal.h
 *
 *  Created on: Sep 4, 2013
 *      Author: Nir Geron
 */

#ifndef GLOBAL_VERIBAL_H_
#define GLOBAL_VERIBAL_H_


	// **  color definition  **
	#define nune_color "\e[m"
	#define green      "\e[1;32m"
	#define blue       "\033[1;34m"
	#define brown      "\033[1;33m"
	#define cyan       "\033[1;36m"


	// **  enum definition  **
	typedef enum Piece  { No_piece  = 0, Rook  = 1, Horse, Bishof, Queen, King, Pioen } PieceType ;
	typedef enum Color  { Empty,White , Black } ColorType ;
	typedef enum Index  { q = 0 ,a , b, c, d ,e ,f ,g ,h} Index_Str  ;


	typedef void       (*VPF) (int*, int*, int*, int* );
	int Get_Mov        (VPF,  int*, int* ,int*, int* );
	int Pioen_Mov      ( int* , int* , int* , int* );
	int Rook_Mov       ( int* , int* , int* , int* );
	int Horse_Mov      ( int* , int* , int* , int* );
	int Bishof_Mov     ( int* , int* , int* , int* );
	int Queen_Mov      ( int* , int* , int* , int* );
	int King_Mov       ( int* , int* , int* , int* );
	int No_piece_Mov   ( int* , int* , int* , int* );


	typedef struct Piece_definition
	{
	  PieceType     Piece_Type ;
	  ColorType     Piece_Color;
	  int           Piece_Row;
	  int           Piece_colum ;
	  char          Piece_TypeName[10];
	  char          Piece_TypeName2[2];
	  char          Piece_colorname[10];
	  char          colum_index ;
	  void          (*Piece_Mov)(int * , int * , int *, int *);
	  int           First_mov ;

	}Piece_sturct;


	Piece_sturct Piecedef[9][9] ;
	Piece_sturct Temp[1][10] ;
	int First_mov_Temp[1][10];


	int  x; int king_white_attact ; int  king_black_attact  ; int king_math  ;
	int turn ; int  p_counter ; int  turn_flag ;



#endif /* GLOBAL_VERIBAL_H_ */
